N=10^4;
d=randi([2,4]);
A=fc_linalg3D.eye(N,d);
fprintf('Computing determinants of the N-by-d-by-d 3D array A where \n')
fprintf('   A(k,:,:) is the identity matrix, for all k\n')
fprintf('and N=%d, d=%d\n',N,d)
Dex=ones(N,1); % exact determinants

funs={'det_Ref','detLaplace_Cpt','detLaplace_Mat','detLaplace_Vec','detLapIdx_Vec', ...
      'det_pLUinplace_Vec','det_pLUinplace_Vec'};
      
for i=1:length(funs)
  cfun=funs{i};
  fun=eval(['@(varargin) fc_linalg3D.det.',funs{i},'(varargin{:})']);
  D=fun(A);
  fprintf('Error=%.4f with %s function\n',max(abs(D-Dex)),func2str(fun))
end
